<?php

/**
 * Processes a response from Semantria.
 */
function _semantria_callback_process() {

  // Responds with a status code.
  http_response_code(200);

  // Wraps the information.
  $parameters = drupal_get_query_parameters();
  $contents = file_get_contents('php://input');
  $response = array(
    'type' => $parameters['type'],
    'contents' => json_decode($contents),
  );

  // Logs response.
  if (variable_get('semantria_debug_status', FALSE)) {
    watchdog('semantria', 'Semantria callback handler: Received data: @data', array('@data' => json_encode($response)));
  }

  // A test trough the UI will save a local document.
  if (strpos($response['contents'][0]->id, 'semantria_test:') !== FALSE) {
    $filename = str_replace('semantria_test:', '', $response['contents'][0]->id);
    file_put_contents(file_directory_temp() . "/response.{$filename}.txt", $contents);
  }

  // Shares the information with the rest of the modules trough a hook.
  module_invoke_all('semantria_process_response', $response);

}
